ingress-nginx-helm/test/e2e/run.sh

95 lines
2.9 KiB
Bash
Raw Normal View History

2019-03-20 21:00:00 +00:00
#!/bin/bash
2019-05-14 02:31:30 +00:00
# Copyright 2019 The Kubernetes Authors.
2019-03-20 21:00:00 +00:00
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
2020-01-30 14:42:57 +00:00
KIND_LOG_LEVEL="1"
2019-05-14 02:31:30 +00:00
if ! [ -z $DEBUG ]; then
set -x
KIND_LOG_LEVEL="6"
2019-05-14 02:31:30 +00:00
fi
set -o errexit
set -o nounset
set -o pipefail
2019-03-20 21:00:00 +00:00
2020-01-30 14:42:57 +00:00
cleanup() {
if [[ "${KUBETEST_IN_DOCKER:-}" == "true" ]]; then
kind "export" logs --name ${KIND_CLUSTER_NAME} "${ARTIFACTS}/logs" || true
fi
kind delete cluster \
--verbosity=${KIND_LOG_LEVEL} \
--name ${KIND_CLUSTER_NAME}
}
trap cleanup EXIT
2020-02-13 00:17:26 +00:00
if ! command -v kind --version &> /dev/null; then
echo "kind is not installed. Use the package manager or visit the official site https://kind.sigs.k8s.io/"
exit 1
fi
2020-06-25 01:46:47 +00:00
if ! command -v ginkgo &> /dev/null; then
go get github.com/onsi/ginkgo/ginkgo
fi
2019-03-20 21:00:00 +00:00
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
# Use 1.0.0-dev to make sure we use the latest configuration in the helm template
export TAG=1.0.0-dev
export ARCH=${ARCH:-amd64}
2019-05-14 02:31:30 +00:00
export REGISTRY=ingress-controller
2019-03-20 21:00:00 +00:00
2020-06-29 22:26:34 +00:00
export K8S_VERSION=${K8S_VERSION:-v1.18.4@sha256:d8ff5fc405fc679dd3dd0cccc01543ba4942ed90823817d2e9e2c474a5343c4f}
export DOCKER_CLI_EXPERIMENTAL=enabled
export KIND_CLUSTER_NAME=${KIND_CLUSTER_NAME:-ingress-nginx-dev}
2019-03-20 21:00:00 +00:00
2019-05-14 02:31:30 +00:00
echo "[dev-env] creating Kubernetes cluster with kind"
export KUBECONFIG="${HOME}/.kube/kind-config-${KIND_CLUSTER_NAME}"
kind create cluster \
--verbosity=${KIND_LOG_LEVEL} \
--name ${KIND_CLUSTER_NAME} \
--config ${DIR}/kind.yaml \
2020-01-30 14:42:57 +00:00
--retain \
2019-09-03 20:46:43 +00:00
--image "kindest/node:${K8S_VERSION}"
2019-03-20 21:00:00 +00:00
echo "Kubernetes cluster:"
kubectl get nodes -o wide
2020-05-31 03:25:56 +00:00
echo "[dev-env] building image"
2020-06-25 01:46:47 +00:00
make -C ${DIR}/../../ clean-image build image
make -C ${DIR}/../e2e-image image
#make -C ${DIR}/../../images/fastcgi-helloserver/ build image
#make -C ${DIR}/../../images/echo/ image
2019-09-05 15:46:53 +00:00
# Preload images used in e2e tests
KIND_WORKERS=$(kind get nodes --name="${KIND_CLUSTER_NAME}" | grep worker | awk '{printf (NR>1?",":"") $1}')
2019-05-14 02:31:30 +00:00
echo "[dev-env] copying docker images to cluster..."
2020-06-25 01:46:47 +00:00
kind load docker-image --name="${KIND_CLUSTER_NAME}" --nodes=${KIND_WORKERS} nginx-ingress-controller:e2e
kind load docker-image --name="${KIND_CLUSTER_NAME}" --nodes=${KIND_WORKERS} ${REGISTRY}/nginx-ingress-controller:${TAG}
#kind load docker-image --name="${KIND_CLUSTER_NAME}" --nodes=${KIND_WORKERS} ${REGISTRY}/fastcgi-helloserver:${TAG}
#kind load docker-image --name="${KIND_CLUSTER_NAME}" --nodes=${KIND_WORKERS} ${REGISTRY}/echo:${TAG}
2019-05-14 02:31:30 +00:00
echo "[dev-env] running e2e tests..."
2019-03-20 21:00:00 +00:00
make -C ${DIR}/../../ e2e-test